#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include "stack.h"

static unsigned int top; /* first free slot on the stack */
static int *data;
static unsigned int size;

void init(void)
{
	top=0;
	size=0;
	data=0;
}

void finalize(void)
{
  free(data);
}

void clear(void)
{
	top=0;
}

void push(int a)
{
	if(top>=size)
	{
	  int newsize=(size+1)*2;
	  int* ndata=realloc(data,newsize*sizeof(int));
	  if(ndata)
	    data=ndata;
	  else
	  {
	    free(data);
	    abort();
	  }
	  fprintf(stderr,"Stack size %d -> %d\n",size,newsize);
	  size=newsize;
	}
	data[top++]=a;
}

int pop(void)
{
	assert(top>0);
	return data[--top];
}

int peek(void)
{
	assert(top>0);
	return data[top-1];
}

int empty()
{
  return(top==0);
}
