#include <assert.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void add_char(char c, char **where, size_t *size) {
  if (*size == (size_t)(-1))
    abort();
  char *newptr = realloc(*where, (*size) + 1);
  if (!newptr)
    abort();
  *where = newptr;
  newptr[*size] = c;
  ++(*size);
}

char *getword() {
  char *w = NULL;
  size_t size = 0;
  int c;
  enum { SKIPPING, READING } state = SKIPPING;

  while ((c = getchar()) != EOF) {
    switch (state) {
    case SKIPPING:
      if (isalpha(c)) {
        state = READING;
        add_char(c, &w, &size);
      }
      break;
    case READING:
      if (!isalpha(c)) {
        goto end_loop;
      }
      add_char(c, &w, &size);
      break;
    }
  }
end_loop:

  if (0 == size)
    return NULL;
  // finish word and return it
  add_char('\0', &w, &size);
  return w;
}

void print_word_if_contains_r(char *w) {
  size_t len = strlen(w);
  size_t i;
  for (i = 0; i < len; ++i)
    if (w[i] == 'r') {
      printf("%s\n", w);
      break;
    }
}

int main() {
  char *w;

  while ((w = getword())) {
    print_word_if_contains_r(w);
    free(w);
  }
  return 0;
}
